Subject: SLI/ACCM race condition

From: Jacob Teplitsky <[email-masked]>
Date: Tue, 18 Jan 2000 11:49:37 -0800 (PST)

> Date: Tue, 18 Jan 2000 23:29:56 -0800
> From: "W. Mark Townsley" <[email-masked]>
> Subject: Re: l2tp-digest V1000 #171
> 
> Barney Wolff wrote:
> > 
> > Um, well, ordering of data vs control packets is not guaranteed by
> > the intervening transport medium.
> > 
> > There are really only three ways to go (that I can think of :)

Well, we can add a new AVP to SLI:
- data packet AVP. The last LCP ACK that finish the LCP negotiations
 can be sent with the SLI message.
................

> > After all, the worst that happens if the wrong ACCM is applied is
> > that the packet is ignored, and packets get lost once in a while
> > anyway.
> 
> No, the worst is that the packet is *always* dropped, so LCP never
> completes, and the call itself is dropped. 

If we use data packet AVP, this can't happen.

Thanks
- Jacob

---

From: Jacob Teplitsky <[email-masked]>
Date: Tue, 18 Jan 2000 14:09:10 -0800 (PST)

In any case I would like to add the requirement that the LNS 
SHOULD send
the last LCP ACK that finish the LCP negotiations and the SLI message
in the right order.
- Jacob
> Jacob Teplitsky wrote:
> This corrects the race condition at its core by packaging the two
> contenders into a single packet so that one cannot beat the other to the
> finish. However, it is a considerable protocol change which would set us
> back interoperabilty-wise. Sniffing a few packets at the LAC, only when
> the SLI is received, and only for a short time, may be better given the
> potential disruption. Further, if we are going to change RFCs, I would
> like to see changes in the PPP RFC to reflect what conventional wisdom
> in the PPP group already seems to be (e.g. be liberal in acceptance of
> unescaped characters). Either protocol change would fix the problem
> theoretically, but niether would help our situation much given the
> current level of deployment. Sniffing a few packets at the LAC starts to
> seem less painful... But I am still open to more suggestions and
> concerns...
> 
> > ................
> >

---

From: "W. Mark Townsley" <[email-masked]>
Date: Wed, 19 Jan 2000 13:29:17 -0800